'use strict';

var react = require('react');
var usehooksTs = require('usehooks-ts');

var useLoadScript = function (_a) {
  var script = _a.script;
  var status = usehooksTs.useScript(script);
  var _b = react.useState(false),
    init = _b[0],
    setInit = _b[1];
  react.useEffect(function () {
    if (status !== "ready") return;
    setInit(true);
  }, [status]);
  return {
    init: init
  };
};

var MANIFEST_SCRIPT = 'https://bridge.usemanifest.com/Manifest.js';

var useManifestBridge$1 = function (config) {
  var _a = react.useState(),
    manifest = _a[0],
    setManifest = _a[1];
  var status = usehooksTs.useScript(MANIFEST_SCRIPT);
  react.useEffect(function () {
    console.log({
      status: status
    });
    if (status === "loading") return;
    if (status === "error") {
      console.error("Error loading Manifest");
      return;
    }
    if (status === "ready" && !window.Manifest) {
      console.error("Error loading Manifest");
    }
  }, [status]);
  react.useEffect(function () {
    console.log({
      config: config
    });
    if (window.Manifest) {
      var manifestObj = window.Manifest.create(config);
      setManifest(manifestObj);
    }
  }, [config]);
  return {
    open: manifest ? manifest.open : function () {}
  };
};

var useExtractHooks = function () {
  return {
    message: "another mock hooks - fixes trial"
  };
};

var useScript = function (url) {
  react.useEffect(function () {
    var script = document.createElement("script");
    script.src = url;
    script.async = true;
    document.body.appendChild(script);
    return function () {
      document.body.removeChild(script);
    };
  }, [url]);
};

var useManifestBridge = function (config) {
  var _a = react.useState(),
    manifest = _a[0],
    setManifest = _a[1];
  var _b = react.useState(false),
    scriptLoaded = _b[0],
    setScriptLoaded = _b[1];
  react.useEffect(function () {
    var script = document.createElement("script");
    script.src = MANIFEST_SCRIPT;
    script.async = true;
    document.body.appendChild(script);
    setScriptLoaded(true);
    return function () {
      document.body.removeChild(script);
    };
  }, []);
  react.useEffect(function () {
    console.log({
      config: config
    });
    console.log(window.Manifest);
    console.log({
      scriptLoaded: scriptLoaded
    });
    if (!scriptLoaded) return;
    if (window.Manifest) {
      var manifestObj = window.Manifest.create(config);
      setManifest(manifestObj);
    }
  }, [config, scriptLoaded]);
  return {
    open: manifest ? manifest.open : function () {}
  };
};

exports.useExtractHooks = useExtractHooks;
exports.useLoadScript = useLoadScript;
exports.useManifestBridge = useManifestBridge$1;
exports.useManifestBridge2 = useManifestBridge;
exports.useScript = useScript;
